LearnMVC/LearnMVC/Controllers/FormationController.cs
using CoreData;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using System.Data.Entity;
using LearnMVC.Models;

namespace LearnMVC.Controllers
{
    [Authorize(Roles = "Admin, Commercial")]
    public class FormationController : Controller
    {
        // GET: Formation
        public ActionResult Index()
        {

            using (var db = new AvisFormationEntities())
            {
                var listFormation = db.Formation.OrderBy(x => x.Nom)
                                                .ToList();

                var listformationDto = new List<FormationAvecAvisDto>();

                foreach (var f in listFormation)
                {
                    var dto = new FormationAvecAvisDto();
                    dto.Formation = f;

                    if (f.Avis.Count == 0)
                        dto.Note = 0;
                    else
                        dto.Note = Math.Round(f.Avis.Average(a => a.Note), 2);



                    listformationDto.Add(dto);
                }

                return View(listformationDto);
            }
        }

        // GET: Formation/Details/5
        public ActionResult Details(int id)
        {
            // Un rigolo
            if (id <= 0)
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);

            using (var db = new AvisFormationEntities())
            {
                var selectedFormation = db.Formation.Include(f => f.Avis)
                                                .FirstOrDefault(f => f.Id == id);

                // Un rigolo
                if (selectedFormation == null)
                    return HttpNotFound();

                return View(selectedFormation);

            }
        }

        // GET: Formation/Create
        public ActionResult Create()
        {
            return View();
        }

        // POST: Formation/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create(Formation formation)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    using (var db = new AvisFormationEntities())
                    {
                        db.Formation.Add(formation);
                        db.SaveChanges();
                    }

                    return RedirectToAction("Index");
                }
                else
                    return View();
            }
            catch
            {
                return View();
            }
        }

        // GET: Formation/Edit/5
        public ActionResult Edit(int id)
        {
            // Un rigolo
            if (id <= 0)
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);

            using (var db = new AvisFormationEntities())
            {
                var selectedFormation = db.Formation.Include(f => f.Avis)
                                                .FirstOrDefault(f => f.Id == id);

                // Un rigolo
                if (selectedFormation == null)
                    return HttpNotFound();

                return View(selectedFormation);
            }
        }

        // POST: Formation/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit(Formation formation)
        {
            try
            {
                if (ModelState.IsValid)
                {
                    using (var db = new AvisFormationEntities())
                    {
                        db.Entry(formation).State = EntityState.Modified;
                        db.SaveChanges();
                    }
                    return RedirectToAction("Index");
                }
                else
                    return View(formation);
            }
            catch
            {
                return View();
            }
        }

        // GET: Formation/Delete/5
        public ActionResult Delete(int id)
        {

            try
            {
                using (var db = new AvisFormationEntities())
                {

                    if (id <= 0)
                        return new HttpStatusCodeResult(HttpStatusCode.BadRequest);

                    var selectedFormation = db.Formation.Find(id);

                    if (selectedFormation == null)
                        return HttpNotFound();
                    else
                    {
                        db.Formation.Remove(selectedFormation);
                        db.SaveChanges();
                        return RedirectToAction("Index");
                    }
                }
            }
            catch
            {
                return View();
            }


            // Un rigolo
            /*if (id <= 0)
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);

            using (var db = new AvisFormationEntities())
            {
                var selectedFormation = db.Formation.Include(f => f.Avis)
                                                .FirstOrDefault(f => f.Id == id);

                // Un rigolo
                if (selectedFormation == null)
                    return HttpNotFound();

                return View(selectedFormation);
            }*/

        }

        // POST: Formation/Delete/5
        [HttpPost]
        public ActionResult Delete(int id, string nomSeo)
        {
            try
            {
                using (var db = new AvisFormationEntities())
                {
                    var selectedFormation = db.Formation.Find(id);

                    if (selectedFormation == null)
                        return HttpNotFound();
                    else {
                        db.Formation.Remove(selectedFormation);
                        db.SaveChanges();
                        return RedirectToAction("Index");
                    }
                }
            }
            catch
            {
                return View();
            }
        }
    }
}

LearnMVC/LearnMVC/Controllers/HomeController.cs
using CoreData;
using LearnMVC.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace LearnMVC.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            using (var db = new AvisFormationEntities())
            {

                var listFormation = db.Formation.OrderBy(x => Guid.NewGuid())
                                                .Take(4)
                                                .ToList();

                var listformationDto = new List<FormationAvecAvisDto>();

                foreach (var f in listFormation)
                {
                    var dto = new FormationAvecAvisDto();
                    dto.Formation = f;

                    if (f.Avis.Count == 0)
                        dto.Note = 0;
                    else
                        dto.Note = Math.Round(f.Avis.Average(a => a.Note), 2);



                    listformationDto.Add(dto);
                }

                return View(listformationDto);
            }
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}

LearnMVC/LearnMVC/Views/Home/About.cshtml
@{
    ViewBag.Title = "About";
}
<h2>@ViewBag.Title.</h2>
<h3>@ViewBag.Message</h3>

<p>Use this area to provide additional information.</p>

LearnMVC/LearnMVC/Views/Home/Contact.cshtml
@{
    ViewBag.Title = "Contact";
}
<h2>@ViewBag.Title.</h2>
<h3>@ViewBag.Message</h3>

<address>
    One Microsoft Way<br />
    Redmond, WA 98052-6399<br />
    <abbr title="Phone">P:</abbr>
    425.555.0100
</address>

<address>
    <strong>Support:</strong>   <a href="mailto:Support@example.com">Support@example.com</a><br />
    <strong>Marketing:</strong> <a href="mailto:Marketing@example.com">Marketing@example.com</a>
</address>

LearnMVC/LearnMVC/Views/Home/Index.cshtml
@model IEnumerable<LearnMVC.Models.FormationAvecAvisDto>

@{
    ViewBag.Title = "Home Page";
}

<div class="jumbotron text-center">
    <h1>Avis Formation</h1>
    <p>Choisissez la meilleure formation !</p>
</div>

<div class="container-fluid containerHome">

    @foreach (LearnMVC.Models.FormationAvecAvisDto dto in Model)
    {
        <article class="info-block col-md-3 col-sm-6">
            <h4>
                @Html.ActionLink(dto.Formation.Nom, "Details", "Formation", new { id = dto.Formation.Id }, new { @class = "lien-formation" })
            </h4>
            <p>
                @if (dto.Note == 0)
                {
                    <span>Aucun Avis</span>
                }
                else
                {
                    for (int i = 0; i < dto.Note; i++)
                    {
                        <i class="fas fa-star"></i>
                    }
                    <span>@dto.Note / 5</span>
                }
            </p>
            <p>@dto.Formation.Description</p>
        </article>
    }
</div>


<div class="container bg-white text-center padding30">
    <h2>Pourquoi utiliser Avis Formation ?</h2>
    <h3>Bénéfices formateur</h3>

    <div class="row">
        <div class="col-md-6">
            <span class="glyphicon glyphicon-shopping-cart logo-small"></span>
            <h4>Conversion</h4>
            <p>Améliorez votre taux de conversion</p>
        </div>
        <div class="col-md-6">
            <span class="glyphicon glyphicon-fullscreen logo-small"></span>
            <h4>Visibilité </h4>
            <p>Améliorez votre visibilité</p>
        </div>
        <div class="col-md-6">
            <span class="glyphicon glyphicon-tree-deciduous logo-small"></span>
            <h4> Fidélisation</h4>
            <p>Obtenez des clients plus fidèles et engagés</p>
        </div>
        <div class="col-md-6">
            <span class="glyphicon glyphicon-heart-empty logo-small"></span>
            <h4>Confiance</h4>
            <p>Vous bénéficiez des retours d'anciens élèves pour améliorer vos produits</p>
        </div>

    </div>
</div>
<div class="container text-center padding30">
    <div class="row">
        <div class="col-md-8">
            <h3> Professionnels de la formation, affichez notre badge sur votre site pour augmenter vos conversions !</h3>
        </div>
        <div class="col-md-4">
            <div class="widget">
                <div>
                    Avis Elèves 4.8 / 5
                    <span class="glyphicon glyphicon-star yellow"></span><span class="glyphicon glyphicon-star yellow"></span><span class="glyphicon glyphicon-star yellow"></span><span class="glyphicon glyphicon-star yellow"></span><span class="glyphicon glyphicon-star yellow"></span>
                </div>
                <div class="widget-bottom">
                    Avis récoltés par AvisFormation.fr
                </div>
            </div>
        </div>
    </div>
</div>
<div class="container bg-white text-center padding30">
    <div class="row">
        <div class="col-md-3">
            <p class="bigpercent">85%</p>
            <p><b>85% des internautes consultent les avis clients avant d'acheter en ligne</b></p>
        </div>
        <div class="col-md-3">
            <p class="bigpercent">91%</p>
            <p><b>91% de ceux qui lisent les avis les considèrent comme le vecteur numéro 1 dans leur décision d'achat</b></p>
        </div>
        <div class="col-md-3">
            <p class="bigpercent">25%</p>
            <p><b>+25% du taux de conversion pour les sites avec étoiles Google</b></p>

        </div>
        <div class="col-md-3">
            <p class="bigpercent"> 80%</p>
            <p><b>80 % des avis ont une note et un commentaire positifs</b></p>
        </div>
    </div>
</div>